<?php
/************************************************************************/
/* Copyright Russell McGuire 2001-2007                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Building Block                                         */
/*                                                                      */
/* Name: Login                                                          */
/*                                                                      */
/* Description: This simple program allows a user to login to be able   */
/* to access capabilities enabled by other Living Stones building       */
/* blocks.  It sets a session variable of lsuid which is an index into  */
/* the Living Stones user table.  This user id is then checked by all   */
/* other Living Stones web blocks whenever secured access is required.  */
/*                                                                      */
/* This building block can operate as a standalone page.  It will be    */
/* referenced by other building block code, so if the filename is       */
/* changed or if it is not local to other building blocks, those other  */
/* building blocks will need to be modified to find this one.           */
/*                                                                      */
/* This page can be modified to make it stylistically consistent with   */
/* the rest of your site as long as the functionality isn't changed.    */
/*                                                                      */
/* This building block assumes that every user should have a password   */
/* and if one isn't set, then the user will be prompted for one the     */
/* first time they log in.  If you want to allow users to log in without*/
/* a password, you can modify the program at that point below.          */
/*                                                                      */
/************************************************************************/

session_start();

/* get include files */
require_once("./ls_include/DBfunctions.php");

/* connect to the Living Stones database */
open_database();

$thisscript = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];

/* find out where the user came from so we can return him there when he's done */
$return_path = $_GET["return_path"];
$return_path = trim($return_path);
if(strlen($return_path) < 1) $return_path = $_POST["return_path"];
$return_path = trim($return_path);
if(strlen($return_path) < 1) $return_path = "ls_index.php";

/*********************************************************************/
/* find out where we are in the process of logging the user in       */
/* login_state = 0: first attempt at logging in                      */
/* login_state = 1: password e-mailed to user, start over            */
/* login_state = 2: e-mail/userid doesn't exist                      */
/* login_state = 3: a password hasn't yet been set                   */
/* login_state = 4: the password entered is wrong                    */
/* login_state = 5: the two passwords entered (new user) don't match */
/* login_state = 6: successfully logged in                           */
/*********************************************************************/
$login_state = $_POST["login_state"];
if(strlen($login_state) < 1) $login_state = $_GET["login_state"];

$user_name = addslashes($_POST["user_name"]);
if(strlen($user_name) < 1) $user_name = addslashes($_GET["user_name"]);

$message = addslashes($_POST["message"]);
if(strlen($message) < 1) $message = addslashes($_GET["message"]);



/* if the user comes here requesting to log-out, then log him out and get him ready to log in again */
$logout = $_GET["logout"];
if($logout > 0)
	{
	$login_state = 0;
	$_SESSION["lsuid"] = "";
	}

if(strlen($login_state) < 1)
	$login_state = 0; /* first attempt at logging in */

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml11/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Login</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />

<?php
/* if already logged in, then we don't need to be here - go back to where we came from */
if(strlen($_SESSION["lsuid"]) > 0) echo "<meta http-equiv='Refresh' content='0; URL=$return_path'>\n";
?>
<style type="text/css">
<!--
body 
	{
	font-family: Verdana, Arial, Helvetica, sans-serif;
	text-decoration: none;
	}
a 
	{
	text-decoration: none;
	color: black;
	}
a:hover 
	{
	font-weight: bold;
	}
-->
</style>

<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
this.window.focus();
</SCRIPT>

</head>
<body onLoad='document.forms[0].elements[0].focus()'>
<?php
/* check to see if the user hit the Login button */
$update = $_POST["update"];
if(strlen($update) > 0)
	{
	$user_pw = addslashes($_POST["user_pw"]);
	$user_pw2 = addslashes($_POST["user_pw2"]);
	/* if you want passwords to be encrypted in your database, then uncomment the following line */
	/* $user_pw_enc = addslashes(md5($user_pw)); */
	/* if you encrypt the passwords, then you'll not be able to e-mail passwords to users */

	/* see if this user exists in the database, and if so, get the password */
	$query = "SELECT id,Password FROM ls_users WHERE Email='$user_name'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		/* if the database password is empty, then let the user set it */
		if(strlen($row[1]) < 1)
			{
			if(strlen($user_pw2) > 0)
				{
				if($user_pw == $user_pw2)
					{
					$login_state = 6; /* logged in */
					$_SESSION["lsuid"]  = $row[0];

					/* if you want to store passwords encrypted, */
					/* change user_pw to user_pw_enc             */
					$q2 = "UPDATE ls_users SET Password=".
						"'$user_pw' WHERE id='$row[0]'";
					sql_getresult($q2);

					echo "<script language='javascript'>\n";
					echo "window.location = '$return_path';\n";
					echo "</script>\n";
					}
				else
					$login_state = 5; /* 2 passwords don't match */
				} /* end if the second password was entered */
			else
				$login_state = 3; /* password not yet set */
			} /* end if no password set */

		/* if the user requested that his password be e-mailed to him, then do so */
		elseif($login_state == 1)
			{ 
			$toaddress = stripslashes($user_name);
			$user_parts = explode("@",$toaddress);
			mail(trim($toaddress),"Requested Info",trim(stripslashes($row[1])),
				"From: ".trim($user_parts[0]));
			}

		else
			{
			/* if you want to store passwords encrypted, */
			/* change user_pw to user_pw_enc             */
			if($row[1] == $user_pw)
				{
				$login_state = 6; /* logged in */
				$_SESSION["lsuid"] = $row[0];
				/* update last logged in             */
				$q2 = "UPDATE ls_users SET LastLogin=NOW()".
					" WHERE id='$row[0]'";
				sql_getresult($q2);
				echo "<script language='javascript'>\n";
				echo "window.location = '$return_path';\n";
				echo "</script>\n";

				}
			else
				{
				$login_state = 4; /* wrong password */
				$user_pw = '';
				}
			} /* end if else - password set and not e-mailed to user */
		}
	else
		$login_state = 2; /* user doesn't exist */

	$user_pw = stripslashes($user_pw);
	$user_pw2 = stripslashes($user_pw2);
	} /* end if submit */
$user_name = stripslashes($user_name);

?>
<form action="<?php echo $thisscript;?>" method="post">
<table width=100% border=0>
<col width=20%><col width=60%><col width=20%>

<tr><td bgcolor=#FFFFFF><td valign=top align=center bgcolor=#F0F0FF>
<?php/*******************************************************************/
/* You probably want to change the name of what people are logging into */
/**********************************************************************/?>
<br><b>Login to Living Stones</b><br><br>
<table>
<?php
if(strlen($message) > 0)
	{
	echo "<tr><td colspan=2 align=center><font color=red>".
		urldecode($message).
		"</font></td></tr>\n";
	}
if($login_state == 1)
	{
	echo "<tr><td colspan=2 align=center><font color=red>".
		"The password has been mailed to $user_name.<br />".
		"Please check your e-mail and enter the correct password below.</font></td></tr>\n";
	}
if($login_state == 2)
	{
	echo "<tr><td colspan=2 align=center><font color=red>".
		"That E-mail address doesn't exist in the system.";
/*************************************************************************/
/* If you don't want people to be able to register themselves as users   */
/* then delete the following line.  You might want to replace it with    */
/* info on contacting an administrator to be added to the system.        */
/*************************************************************************/
	echo "<br />\n<a href='ls_register_user.php?return_path=$return_path&Email=$user_name'>".
		"Click here</a> to register yourself as a Living Stones user.";
	echo "</font></td></tr>\n";
	}
if($login_state == 3)
	{
	echo "<tr><td colspan=2 align=center><font color=red>".
		"A password has not yet been set for this userid.<br />".
		"Please enter the password twice below to confirm.</font></td></tr>\n";
	}
if($login_state == 4)
	{
	echo "<tr><td colspan=2 align=center><font color=red>".
		"The password you entered is incorrect.<br>".
		"Please try again.</font></td></tr>\n";
/*************************************************************************/
/* You'll need to remove the following echo statement if you are storing */
/* passwords encrypted.                                                  */
/*************************************************************************/
	echo "<tr><td colspan=2 align=center><a href=$thisscript?sendpw=1&user_name=$user_name".
		"&login_state=1&return_path=$return_path>".
		"Click here to have your password e-mailed to you.</a></td></tr>\n";
	}
if($login_state == 5)
	{
	echo "<tr><td colspan=2 align=center><font color=red>".
		"The two passwords you entered don't match.<br />".
		"Please try again.</font></td></tr>\n";
	}
?>
<tr><td align=right>Your E-mail Address:</td>
<td align=left>
<input type=text name=user_name size=30 tabindex=1 value='<?php echo $user_name;?>'></td></tr>
<tr><td align=right>Password:</td>
<td align=left>
<input type=password name=user_pw size=30 tabindex=2 value='<?php echo $user_pw;?>'></td></tr>
<?php
if(($login_state == 3) OR ($login_state == 5))
	{
	echo "<tr><td align=right>Password (confirm):</td>\n".
		"<td align=left>\n".
		"<input type=password name=user_pw2 size=30></td></tr>\n";
	}
?>
<tr><td colspan=2 align=center><input type="submit" name="update" value="Login"></td></tr>

<?php/****************************************************************************/
/* If you've placed the registration form elsewhere, change the below link       */
/*******************************************************************************/?>
<tr><td colspan=2 align=center><a style="color: red;" href="ls_register_user.php">Register Here</a>, if not a current user.</td></tr>
</table>
</td>

<td valign=top align=left bgcolor=#FFFFFF>
</td>
</tr>

</table>
<input type=hidden name=login_state value=<?php echo $login_state;?>>
<input type=hidden name=return_path value='<?php echo $return_path;?>'>
</form>

<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LS-sm.gif"></a>
</body>
</html>
