<?php
/************************************************************************/
/* Copyright Russell McGuire 2001-2007                                  */
/* Provided under Living Stones Software License Agreement              */
/* By using or sharing this software with others, you agree to be bound */
/* by the terms of that agreement.                                      */
/* E-mail russ.mcguire@seek-first.com if you don't have a copy          */
/************************************************************************/

/************************************************************************/
/* Living Stones Building Block                                         */
/*                                                                      */
/* Name: Register User                                                  */
/*                                                                      */
/* Description: This simple program allows a new user to register to    */
/* use the system.  This program should be removed from your site if    */
/* you don't want users to be able to register themselves.  As it is,   */
/* this will give the user the lowest level of access to the system.    */
/*                                                                      */
/* This building block can operate as a standalone page.  It will be    */
/* referenced by other building block code, so if the filename is       */
/* changed or if it is not local to other building blocks, those other  */
/* building blocks will need to be modified to find this one.           */
/*                                                                      */
/* This page can be modified to make it stylistically consistent with   */
/* the rest of your site as long as the functionality isn't changed.    */
/*                                                                      */
/* This building block doesn't set the password for the user.  The      */
/* ls_login.php program, unless you've changed it, will ask them to     */
/* choose a password the first time they login.                         */
/*                                                                      */
/************************************************************************/

session_start();

/* get include files */
require_once("./ls_include/DBfunctions.php");
require_once("./ls_include/Authfunctions.php");

/* connect to the Living Stones database */
open_database();

$thisscript = "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME'];

/* find out where the user came from so we can return him there when he's all done */
$return_path = $_GET["return_path"];
$return_path = trim($return_path);
if(strlen($return_path) < 1) $return_path = $_POST["return_path"];
$return_path = trim($return_path);
if(strlen($return_path) < 1) $return_path = "ls_index.php";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml11/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Register</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />

<?php
/* if already logged in, then we don't need to be here - go back to where we came from */
if(strlen($_SESSION["lsuid"]) > 0) echo "<meta http-equiv='Refresh' content='0; URL=$return_path'>\n";
?>
<style type="text/css">
<!--
body 
	{
	font-family: Verdana, Arial, Helvetica, sans-serif;
	text-decoration: none;
	}
a 
	{
	text-decoration: none;
	color: black;
	}
a:hover 
	{
	font-weight: bold;
	}
-->
</style>

<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
this.window.focus();
</SCRIPT>

</head>
<body onLoad='document.forms[0].elements[0].focus()'>
<?php
$mismatched_firstname = 0;
$mismatched_lastname = 0;
$mismatched_country = 0;
$mismatched_zip = 0;
/* check to see if the user hit the Register button */
$update = $_POST["update"];
if(strlen($update) > 0)
	{
	/*************************************************************************/
	/* Even though we aren't going to use all of these in the form, I'm      */
	/* including them all here in case you add any to your form.             */
	/*************************************************************************/
	$FirstName = addslashes($_POST["FirstName"]);
	$LastName = addslashes($_POST["LastName"]);
	$Telephone = addslashes($_POST["Telephone"]);
	$Telephone2 = addslashes($_POST["Telephone2"]);
	$Email = addslashes($_POST["Email"]);
	if(strlen($Email) < 1) $Email = addslashes($_GET["Email"]);
	$Email2 = addslashes($_POST["Email2"]);
	$Address = addslashes($_POST["Address"]);
	$Address2 = addslashes($_POST["Address2"]);
	$City = addslashes($_POST["City"]);
	$State = addslashes($_POST["State"]);
	$Zip = addslashes($_POST["Zip"]);
	$Country = addslashes($_POST["Country"]);
	$Birthday = addslashes($_POST["Birthday"]);
	$Age = addslashes($_POST["Age"]);
	$Grade = addslashes($_POST["Grade"]);

	/* Check for required data */
	/* You can add as many as you like */
	$missing_email = 0;
	$invalid_email = 0;
	$existing_user = 0;
	$existing_person = 0;
	$regexp = "^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$";

	if(strlen($Email) < 1)
		$missing_email = 1;

	elseif(!eregi($regexp , $Email))
		$invalid_email = 1;

	/* now check to see if this user already exists in either People or Users */
	$query = "SELECT id FROM ls_users WHERE Email='$Email'";
	if(sql_isrecord($query)) $existing_user = 1;

	$query = "SELECT id,FirstName,LastName,Country,Zip FROM ls_people ".
		"WHERE Email = '$Email' OR Email2 = '$Email'";
	$result = sql_getresult($query);
	if($row = sql_getrow($result))
		{
		$existing_person = 1;
		$thisperson = $row[0];
		if($row[1] != $FirstName) $mismatched_firstname = 1;
		if($row[2] != $LastName) $mismatched_lastname = 1;
		if($row[3] != $Country) $mismatched_country = 1;
		if($row[4] != $Zip) $mismatched_zip = 1;
		}

	/* if everything is okay - add to the database */
	if($existing_person < 1)
		{
		$query = "INSERT INTO ls_people SET FirstName='$FirstName',LastName='$LastName',".
			"Email='$Email',Country='$Country',Zip='$Zip'";
		sql_getresult($query);
		$thisperson = sql_getid();
		}

	if(($missing_email < 1) AND ($invalid_email < 1) AND ($existing_user < 1))
		{
		$query = "INSERT INTO ls_users SET PeopleId='$thisperson',Email='$Email',".
				"IsGroup='0',CreationDate=NOW()";
		sql_getresult($query);
		$thisuser = sql_getid();

		/* now add the user into the security tables only able to change his own data */
		$objecttype = sql_getone("SELECT id FROM ls_security_objects WHERE object_desc = 'Users'");
		$selflevel = sql_getone("SELECT id FROM ls_security_levels ".
				"WHERE object_type = '$objecttype' AND auth_name = 'Manage Self'");
		set_auth($thisuser,$objecttype,$thisuser,$selflevel);

		$objecttype = sql_getone("SELECT id FROM ls_security_objects WHERE object_desc = 'People'");
		$selflevel = sql_getone("SELECT id FROM ls_security_levels ".
				"WHERE object_type = '$objecttype' AND auth_name = 'Manage Self'");
		set_auth($thisuser,$objecttype,$thisperson,$selflevel);
		
		/* if there weren't mismatches with existing data take the user to the login page */
		if(($mismatched_firstname < 1) AND ($mismatched_lastname < 1) AND ($mismatched_country < 1)
			AND ($mismatched_zip < 1))
			{
			echo "<script language='javascript'>\n";
			echo "window.location = 'ls_login.php?return_path=$return_path".
				"&user_name=$Email&login_state=3&message=".
				urlencode("Select a Password").
				"';\n";
			echo "</script>\n";
			}
		} /* end if okay to add user */
	

	} /* end if submit */

?>
<form action="<?php echo $thisscript;?>" method="post">
<table width=100% border=0>
<col width=20%><col width=60%><col width=20%>

<tr><td bgcolor=#FFFFFF><td valign=top align=center bgcolor=#F0F0FF>
<?php/**********************************************************************/
/* You probably want to change the name of what people are registering for */
/*************************************************************************/?>
<br><b>Register for Living Stones</b><br><br>
<table>
<?php
if($missing_email == 1)
	{
	echo "<tr><td colspan=6 align=center><font color=red>".
		"You must provide an E-mail address.</font></td></tr>\n";
	}
if($invalid_email == 1)
	{
	echo "<tr><td colspan=6 align=center><font color=red>".
		"The e-mail address is in an invalid format.<br />It should ".
		"be of the form someone@somewhere.com</font></td></tr>\n";
	}

/* Unless the user submitted information that didn't match */
/* what we already have, show the registration form        */
if(($mismatched_firstname < 1) AND ($mismatched_lastname < 1) AND ($mismatched_country < 1)
	AND ($mismatched_zip < 1))
	{
	echo "<tr><td align=right valign=top colspan=2>Your E-mail Address:<br />(Will be your login id)</td>\n";
	echo "<td align=left valign=top colspan=4>\n";
	echo "<input type=text name=Email size=40 tabindex=1 ".
		"value='".stripslashes($Email)."'></td></tr>\n";
	echo "<tr><td align=right colspan=2 valign=top>Your Name:<br /></td>\n";
	echo "<td align=left colspan=4 valign=top>\n";
	echo "<input type=text name=FirstName size=20 tabindex=2 ".
		"value='".stripslashes($FirstName)."'>\n";
	echo "<input type=text name=LastName size=20 tabindex=3 ".
		"value='".stripslashes($LastName)."'>\n";	echo "</td></tr>\n";
	echo "<tr><td colspan=6></td></tr>\n";
	echo "<tr><td align=right colspan=1>Country:</td>\n";
	echo "<td align=left colspan=2>\n";
	echo "<input type=text name=Country size=15 tabindex=4 ".
		"value='".stripslashes($Country)."'></td>\n";
	echo "<td align=right colspan=2>Postal/Zip:</td>\n";
	echo "<td align=left colspan=1>\n";
	echo "<input type=text name=Zip size=10 tabindex=5 value='".stripslashes($Zip)."'></td>\n";
	echo "<tr><td colspan=6></td></tr>\n";
	echo "<tr><td colspan=6 align=center><input type='submit' name='update' value='Register'></td></tr>\n";
	echo "</table>\n";
	echo "</td>\n\n";

	echo "<td valign=top align=left bgcolor=#FFFFFF>\n";
	echo "</td>\n";
	echo "</tr>\n\n";
	}
else
	{
	/* When the user completed the registration form, either his name, country, or zip code */
	/* didn't match what we already had for someone with the same e-mail address            */

	echo "<tr><td colspan=6 align=center><font color=red>".
		"The data you entered doesn't match what is already in the system.<br />".
		"<a href=ls_login.php?return_path=ls_manage_people.php>Click Here</a> ".
		"to login and correct the data,<br />".
		"or <a href=ls_login.php?return_path=$return_path>Click Here</a> ".
		"to simply login.</font></td></tr>\n";
	}
	
?>
</table>
<input type=hidden name=return_path value='<?php echo $return_path;?>'>
</form>

<a href="http://www.lstones.com/"><img border=0 src="http://www.lstones.com/LS-sm.gif"></a>
</body>
</html>
